# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      user_read_ini.py
# Author:       wen
# Datetime:     2024/8/31 上午10:07
# Description:
# 
# ---------------------------------------------------------------------------
""""""
import configparser
import os.path

from Test_3 import log


class ReadIni:
    def __init__(self):
        # 获取数据配置目录的路径
        self.data_config_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "data_config")
        # 获取ini文件的路径
        ini_path = os.path.join(self.data_config_path, "basic_config.ini")
        # 创建Configparser对象
        self.conf = configparser.ConfigParser()
        # Configparser对象调用read方法读取ini文件
        self.conf.read(ini_path, encoding="utf-8")

    def get_host(self, key):
        try:
            # Configparser对象调用get方法获取key对应的值并返回被测系统的域名
            return self.conf.get("host", key)
        except Exception as e:
            # critical--致命错误
            log.error(f"方法get_host,获取被测系统的域名产生错误，传入的key为{key},错误为：{e}")
            raise e

    def get_sql(self, key):
        """根据key获取sql节点下数据库的链接信息"""
        try:
            # 调用get方法获取key对应的值获取数据库的链接信息
            return self.conf.get("sql", key)
        except Exception as e:
            # critical--致命错误
            log.error(f"方法get_sql,获取数据库链接信息产生错误，传入的key为{key},错误为：{e}")
            raise e


if __name__ == '__main__':
    ini = ReadIni()
    ini.get_file_path(1111)
