# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      read_json.py
# Author:       wen
# Datetime:     2024/8/31 上午10:52
# Description:
# 
# ---------------------------------------------------------------------------
import json
import os

from Test_3 import log
from Test_3.common.user_read_ini import ReadIni


def read_json(file_path):
    # 判断传入的路径是否为字符串
    if isinstance(file_path, str):
        # 判断传入的路径是一个文件并以,json结尾
        if os.path.isfile(file_path) and file_path.endswith(".json"):
            try:
                # 读取json文件
                with open(file_path, mode="r", encoding="utf-8") as f:
                    # 将json文件的数据序列化python对象
                    return json.loads(f.read())
                    # return json.load(f)
            except Exception as e:
                log.error(f"读取json文件的数据存在问题，json文件路径为：{file_path}，错误为：{e}")
                raise e
        else:
            # 如果路径不存在或不是以.json结尾的，抛出FileNotFoundError的错误
            raise FileNotFoundError("传入的路径找不到")
    else:
        # 如果路径不是字符串，抛出TypeError错误
        log.error(f"方法read_json执行失败，传入的文件路径为：{file_path},不为字符串")
        raise ValueError("传入的文件路径必须为字符串")


if __name__ == '__main__':
    ini = ReadIni()
    print(read_json(ini.get_file_path("case")))