# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      user_read_ini.py
# Author:       wen
# Datetime:     2024/8/31 上午10:07
# Description:
# 
# ---------------------------------------------------------------------------
""""""
import configparser
import os.path

from Test_3 import log


class ReadIni:
    def __init__(self, username):
        # 获取数据配置目录的路径
        data_config_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "data_config")
        self.user_dir = os.path.join(data_config_path, username)
        # 获取ini文件的路径
        ini_path = os.path.join(self.user_dir, "config.ini")
        # 创建Configparser对象
        self.conf = configparser.ConfigParser()
        # Configparser对象调用read方法读取ini文件
        self.conf.read(ini_path, encoding="utf-8")

    def get_file_path(self, key):
        try:
            log.info(f"执行方法为get_file_path,获取file节点下的key对应的值，传入的key为{key}")
            # Configparser对象调用get方法获取key对应的值
            file_name = self.conf.get("file", key)
        except Exception as e:
            # critical--致命错误
            log.error(f"方法get_file_path执行失败，传入的key为{key},错误为：{e}")
            raise e
        else:
            # 返回拼接文件的路径
            return os.path.join(self.user_dir, file_name)

    def get_table(self, key):
        try:
            # 调用get方法获取key对应的值返回工作表的名称
            return self.conf.get("table", key)
        except Exception as e:
            # critical--致命错误
            log.error(f"方法get_table,获取工作表名称产生错误，传入的key为{key},错误为：{e}")
            raise e


if __name__ == '__main__':
    ini = ReadIni()
    ini.get_file_path(1111)
